#ifndef _LINUX_BYTEORDER_LITTLE_ENDIAN_H
#define _LINUX_BYTEORDER_LITTLE_ENDIAN_H

#ifndef __LITTLE_ENDIAN
#define __LITTLE_ENDIAN 1234
#endif
#ifndef __LITTLE_ENDIAN_BITFIELD
#define __LITTLE_ENDIAN_BITFIELD
#endif

#include <linux/types.h>
#include <linux/byteorder/swab.h>

#define __constant_htonl(x) (___constant_swab32((x)))
#define __constant_ntohl(x) ___constant_swab32((x))
#define __constant_htons(x) (___constant_swab16((x)))
#define __constant_ntohs(x) ___constant_swab16((x))
#define __constant_cpu_to_le64(x) ((__u64)(x))
#define __constant_le64_to_cpu(x) ((__u64)(x))
#define __constant_cpu_to_le32(x) ((__u32)(x))
#define __constant_le32_to_cpu(x) ((__u32)(x))
#define __constant_cpu_to_le16(x) ((__u16)(x))
#define __constant_le16_to_cpu(x) ((__u16)(x))
#define __constant_cpu_to_be64(x) (___constant_swab64((x)))
#define __constant_be64_to_cpu(x) ___constant_swab64((__u64)(x))
#define __constant_cpu_to_be32(x) (___constant_swab32((x)))
#define __constant_be32_to_cpu(x) ___constant_swab32((__u32)(x))
#define __constant_cpu_to_be16(x) (___constant_swab16((x)))
#define __constant_be16_to_cpu(x) ___constant_swab16((__u16)(x))
#define __cpu_to_le64(x) ((__u64)(x))
#define __le64_to_cpu(x) ((__u64)(x))
#define __cpu_to_le32(x) ((__u32)(x))
#define __le32_to_cpu(x) ((__u32)(x))
#define __cpu_to_le16(x) ((__u16)(x))
#define __le16_to_cpu(x) ((__u16)(x))
#define __cpu_to_be64(x) (__swab64((x)))
#define __be64_to_cpu(x) __swab64((__u64)(x))
#define __cpu_to_be32(x) (__swab32((x)))
#define __be32_to_cpu(x) __swab32((__u32)(x))
#define __cpu_to_be16(x) (__swab16((x)))
#define __be16_to_cpu(x) __swab16((__u16)(x))

#define __le64_to_cpus(x) do {} while (0)
#define __cpu_to_le32s(x) do {} while (0)
#define __le32_to_cpus(x) do {} while (0)
#define __cpu_to_le16s(x) do {} while (0)
#define __le16_to_cpus(x) do {} while (0)
#define __cpu_to_be64s(x) __swab64s((x))
#define __be64_to_cpus(x) __swab64s((x))
#define __cpu_to_be32s(x) __swab32s((x))
#define __be32_to_cpus(x) __swab32s((x))
#define __cpu_to_be16s(x) __swab16s((x))
#define __be16_to_cpus(x) __swab16s((x))

#endif /* _LINUX_BYTEORDER_LITTLE_ENDIAN_H */
